#ifndef BASIC_H
#define BASIC_H

/*************************************************************
*                                                            *
*       CGI C++ Library v0.29a                               *
*                                                            *
*       (c) 2005-2007 by Ighor Poteryakhin (ighor@ighor.ru)  *
*                                                            *
*       basic.cpp                                            *
*                                                            *
*************************************************************/

#include <iostream>
#include <cstdlib>
#include <string>
#include <iconv.h>
#include "const.h"

namespace cgi
{

    // implements basic and often used methods for other classes
    class basic
    {
        public:
    	    void move(void*, void*, int);		// moves n bytes from first parametr (pointer) to second
    	    char* itoa(int,char*); 			// number to char*, uses sprintf
    	    char* itoa(int); 				// number to char*, uses sprintf
    	    char* itoh(int,char*); 			// number to char*, hex representation, uses sprintf
    	    char* itoh(int); 				// number to char*, hex representation, uses sprintf
    	    char* hitoa(unsigned char,char*);		// hex number to char*, uses sprintf
    	    char* hitoa(unsigned char); 		// hex number to char*, uses sprintf
    	    int count_sym(const char*,const char);	// count number of char in string
    	    std::string win1251_2_koi8ru(std::string);	// converts string cp1251->koi8-r
	    std::string strip(std::string);		// deletes ' on begin&end of string
	    std::string trim(std::string);		// deletes spaces on begin&end of string
	    std::string safe(const std::string&);	// changes all to * all except 'A'-'z','0'-'9',spaces
	    std::string detag(const std::string&);	// replaces '<' -> '&lt';

	protected:
	    inline bool is_base64(unsigned char c);
    	    std::string base64_encode(unsigned char const* , unsigned int len);
	    std::string base64_decode(std::string const& s);

    	    std::string _gettime(time_t); 	// converts time_t to Wed, 09-Nov-2005 08:10:17
    	    std::string _gettimem(time_t);	// does the same, but puts spaces instead of minuses
						// Wed, 09 Nov 2005 08:10:17 
    };

}
#endif
#include <string>



