#include "urlcode.h"

/*************************************************************
*                                                            *
*       CGI C++ Library v0.29a                               *
*                                                            *
*       (c) 2005-2007 by Ighor Poteryakhin (ighor@ighor.ru)  *
*                                                            *
*       urlcode.cpp                                          *
*                                                            *
*************************************************************/

using namespace urlcode;

namespace urlcode
{

    bool urlbase::issafe(char ch)
    {
	if
	(
	    (ch>='A'&&ch<='Z') ||
	    (ch>='a'&&ch<='z') ||
	    (ch>='0'&&ch<='9')
	)
	    return true;
	else	    
	    return false;
    }

    inline bool urlbase::isunsafe(char ch)
    {
	return !(issafe(ch));
    }

    std::string urlbase::encodechar(char ch)	// " " -> %20
    {
	static std::string s;
	s=hitoa((unsigned char) ch);
	while(s.length()<2)
	    s="0"+s;
        s="%"+s;
	return s;
    }

    char urlbase::decodechar(std::string s)	// %20 -> " "
    {
	if(s.length()!=3)
	    throw "decodechar(): Can't urldecode less or more than three-character string!";
	static int h;
	while(s[0]=='%')
	    s.erase(0,1);
	sscanf(s.c_str(),"%X",&h);
	return (char)h;
    }

    std::string urlencode::encode(std::string s)
    {
	static std::string res;
	res="";
	for(int i=0;i<s.length();i++)
	    if(issafe(s[i]))
		res+=s[i];
	    else
		res+=encodechar(s[i]);
	return res;
    }

    std::string urlencode::encode(const char* s)
    {
	static std::string ss;
	ss=s;
	ss=encode(ss);
	return ss;
    }
    
    std::string urldecode::decode(std::string s) // say FUCK to x-www-urlencoding and RFC 2396 and MS Explorer
    {
	static std::string res;
	res="";
	for(int i=0;i<s.length();i++)
	    if(s[i]!='%')
	    {
		if(issafe(s[i]))
		    res+=s[i];
		else
		    if(s[i]=='+') // plus sign "+" to space
			res+=" ";
		    else	// unreserved charecters
				// "-" | "_" | "." | "!" | "~" | "*" | "'" | "(" | ")"
			switch(s[i])
			{
			    case '-':
			    case '_':
			    case '.':
			    case '!':
			    case '~':
			    case '*':
			    case '\'':
			    case '(':
			    case ')':
			    case '@': // what about this SHIT ???
				res+=s[i];
				break;
			    default:
				throw "Bad urlencoded string (unsafe characters found)!";
			}
	    }
	    else
	    {
		if((i+3)<=s.length())
		    res+=decodechar(s.substr(i,3));
		else
		    throw "Bad urlencoded string (incomplete num?)!";
		i+=2;
	    }
	return res;
    }

    std::string urldecode::decode(const char* s)
    {
	static std::string ss;
	ss=s;
	ss=decode(ss);
	return ss;
    }

}
